diff --git a/sysprep/sysprep_operation_password.ml b/sysprep/sysprep_operation_password.ml
new file mode 100644
index 0000000..a5c894f
--- /dev/null
+++ b/sysprep/sysprep_operation_password.ml
@@ -0,0 +1,162 @@
+(* virt-sysprep
+ * Copyright (C) 2013 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+open Printf
+
+open Sysprep_operation
+open Common_gettext.Gettext
+open Password
+
+module G = Guestfs
+
+let passwords = Hashtbl.create 13
+
+let rec set_root_password arg =
+  set_password "root" arg
+
+and set_user_password arg =
+  let i =
+    try String.index arg ':'
+    with Not_found ->
+      eprintf (f_"virt-sysprep: password: invalid --password format; see the man page.\n");
+      exit 1 in
+  let len = String.length arg in
+  set_password (String.sub arg 0 i) (String.sub arg (i+1) (len-(i+1)))
+
+and set_password user arg =
+  let pw = parse_selector ~prog arg in
+
+  if Hashtbl.mem passwords user then (
+    eprintf (f_"virt-sysprep: password: multiple --root-password/--password options set the password for user '%s' twice.\n") user;
+    exit 1
+  );
+
+  Hashtbl.replace passwords user pw
+
+let password_crypto : password_crypto option ref = ref None
+
+let set_password_crypto arg =
+  password_crypto := Some (password_crypto_of_string ~prog arg)
+
+let password_perform g root =
+  if Hashtbl.length passwords > 0 then (
+    let typ = g#inspect_get_type root in
+    match typ with
+    | "linux" ->
+      let password_crypto = !password_crypto in
+      set_linux_passwords ~prog ?password_crypto g root passwords;
+      [ `Created_files ]
+    | _ ->
+      eprintf (f_"virt-sysprep: cannot set passwords for %s guests.\n") typ;
+      exit 1
+  )
+  else []
+
+let op = {
+  defaults with
+    name = "password";
+
+    (* enabled_by_default because we only do anything if the
+     * --password or --root-password parameter is used.
+     *)
+    enabled_by_default = true;
+
+    heading = s_"Set root or user password";
+    pod_description = Some (s_"\
+Set root or another user's password.
+
+Use the I<--root-password> option to specify a replacement root
+password for the guest.  You can only use this option once.
+
+Use the I<--password> option to specify replacement user password(s).
+You can use this option as many times as you want.
+
+Use I<--password-crypto> to change the password encryption used.
+
+See L</OPTIONS> above for details of these options.
+
+This operation is enabled by default, but it only does something
+if there is at least one I<--root-password> or I<--password>
+argument given.");
+
+    pod_notes = Some (s_"\
+Currently this only works for glibc-based Linux guests that
+use shadow passwords.");
+
+    extra_args = [
+      { extra_argspec = "--root-password", Arg.String set_root_password, s_"..." ^ " " ^ s_"set root password (see man page)";
+        extra_pod_argval = Some "SELECTOR";
+        extra_pod_description = s_"\
+Set the root password.  See I<--password> above for the format
+of C<SELECTOR>."
+      };
+
+      { extra_argspec = "--password", Arg.String set_user_password, s_"..." ^ " " ^ s_"set user password (see man page)";
+        extra_pod_argval = Some "USERNAME:SELECTOR";
+        extra_pod_description = s_"\
+Set a user password.  The user must exist already (this option
+does I<not> create users).
+
+The I<--password> option takes C<USERNAME:SELECTOR>.  The
+I<--root-password> option takes just the C<SELECTOR>.  The
+format of the C<SELECTOR> is described below:
+
+=over 4
+
+=item B<--password USERNAME:file:FILENAME>
+
+=item B<--root-password file:FILENAME>
+
+Read the password from C<FILENAME>.  The whole
+first line of this file is the replacement password.
+Any other lines are ignored.  You should create the file
+with mode 0600 to ensure no one else can read it.
+
+=item B<--password USERNAME:password:PASSWORD>
+
+=item B<--root-password password:PASSWORD>
+
+Set the password to the literal string C<PASSWORD>.
+
+B<Note: this is not secure> since any user on the same machine
+can see the cleartext password using L<ps(1)>.
+
+=back"
+      };
+
+      { extra_argspec = "--password-crypto", Arg.String set_password_crypto, s_"md5|sha256|sha512" ^ " " ^ s_"set password crypto";
+        extra_pod_argval = Some "md5|sha256|sha512";
+        extra_pod_description = s_"\
+Set the password encryption to C<md5>, C<sha256> or C<sha512>.
+
+C<sha256> and C<sha512> require glibc E<ge> 2.7
+(check L<crypt(3)> inside the guest).
+
+C<md5> will work with relatively old Linux guests (eg. RHEL 3), but
+is not secure against modern attacks.
+
+The default is C<sha512> unless libguestfs detects an old guest
+that didn't have support for SHA-512, in which case it will use C<md5>.
+You can override libguestfs by specifying this option."
+      }
+    ];
+
+    perform_on_filesystems = Some password_perform;
+}
+
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_puppet_data_log.ml b/sysprep/sysprep_operation_puppet_data_log.ml
index 7c4fd89..8094b83 100644
--- a/sysprep/sysprep_operation_puppet_data_log.ml
+++ b/sysprep/sysprep_operation_puppet_data_log.ml
@@ -40,14 +40,12 @@ let puppet_data_log_perform g root =
   )
   else []
 
-let puppet_data_log_op = {
-  name = "puppet-data-log";
-  enabled_by_default = true;
-  heading = s_"Remove the data and log files of puppet";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some puppet_data_log_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "puppet-data-log";
+    enabled_by_default = true;
+    heading = s_"Remove the data and log files of puppet";
+    perform_on_filesystems = Some puppet_data_log_perform;
 }
 
-let () = register_operation puppet_data_log_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_random_seed.ml b/sysprep/sysprep_operation_random_seed.ml
index 6beb16f..0e6a2a2 100644
--- a/sysprep/sysprep_operation_random_seed.ml
+++ b/sysprep/sysprep_operation_random_seed.ml
@@ -19,44 +19,24 @@
 open Sysprep_operation
 open Common_gettext.Gettext
 
-module G = Guestfs
+open Random_seed
 
-let random_seed_perform g root =
-  let typ = g#inspect_get_type root in
-  if typ = "linux" then (
-    let files = [
-      "/var/lib/random-seed"; (* Fedora *)
-      "/var/lib/urandom/random-seed"; (* Debian *)
-      "/var/lib/misc/random-seed"; (* SuSE *)
-    ] in
-    List.iter (
-      fun file ->
-        if g#is_file file then (
-          (* Get 8 bytes of randomness from the host. *)
-          let chan = open_in "/dev/urandom" in
-          let buf = String.create 8 in
-          really_input chan buf 0 8;
-          close_in chan;
+module G = Guestfs
 
-          g#write file buf
-        )
-    ) files;
-    [ `Created_files ]
-  )
-  else []
+let random_seed_perform (g : Guestfs.guestfs) root =
+  if set_random_seed g root then [ `Created_files ] else []
 
-let random_seed_op = {
-  name = "random-seed";
-  enabled_by_default = true;
-  heading = s_"Generate random seed for guest";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "random-seed";
+    enabled_by_default = true;
+    heading = s_"Generate random seed for guest";
+    pod_description = Some (s_"\
 Write some random bytes from the host into the random seed file of the
 guest.
 
 See L</RANDOM SEED> below.");
-  extra_args = [];
-  perform_on_filesystems = Some random_seed_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some random_seed_perform;
 }
 
-let () = register_operation random_seed_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_rhn_systemid.ml b/sysprep/sysprep_operation_rhn_systemid.ml
index 6ccf5af..002aa5a 100644
--- a/sysprep/sysprep_operation_rhn_systemid.ml
+++ b/sysprep/sysprep_operation_rhn_systemid.ml
@@ -32,14 +32,12 @@ let rhn_systemid_perform g root =
     []
   | _ -> []
 
-let rhn_systemid_op = {
-  name = "rhn-systemid";
-  enabled_by_default = true;
-  heading = s_"Remove the RHN system ID";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some rhn_systemid_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "rhn-systemid";
+    enabled_by_default = true;
+    heading = s_"Remove the RHN system ID";
+    perform_on_filesystems = Some rhn_systemid_perform;
 }
 
-let () = register_operation rhn_systemid_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_rpm_db.ml b/sysprep/sysprep_operation_rpm_db.ml
index b347c53..551c266 100644
--- a/sysprep/sysprep_operation_rpm_db.ml
+++ b/sysprep/sysprep_operation_rpm_db.ml
@@ -34,16 +34,15 @@ let rpm_db_perform g root =
   )
   else []
 
-let rpm_db_op = {
-  name = "rpm-db";
-  enabled_by_default = true;
-  heading = s_"Remove host-specific RPM database files";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "rpm-db";
+    enabled_by_default = true;
+    heading = s_"Remove host-specific RPM database files";
+    pod_description = Some (s_"\
 Remove host-specific RPM database files and locks.  RPM will
 recreate these files automatically if needed.");
-  extra_args = [];
-  perform_on_filesystems = Some rpm_db_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some rpm_db_perform;
 }
 
-let () = register_operation rpm_db_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_samba_db_log.ml b/sysprep/sysprep_operation_samba_db_log.ml
index 2f6370a..8ed86ca 100644
--- a/sysprep/sysprep_operation_samba_db_log.ml
+++ b/sysprep/sysprep_operation_samba_db_log.ml
@@ -41,14 +41,12 @@ let samba_db_log_perform g root =
   )
   else []
 
-let samba_db_log_op = {
-  name = "samba-db-log";
-  enabled_by_default = true;
-  heading = s_"Remove the database and log files of Samba";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some samba_db_log_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "samba-db-log";
+    enabled_by_default = true;
+    heading = s_"Remove the database and log files of Samba";
+    perform_on_filesystems = Some samba_db_log_perform;
 }
 
-let () = register_operation samba_db_log_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_script.ml b/sysprep/sysprep_operation_script.ml
index 629d624..a3e8838 100644
--- a/sysprep/sysprep_operation_script.ml
+++ b/sysprep/sysprep_operation_script.ml
@@ -112,11 +112,12 @@ trap cleanup INT TERM QUIT EXIT ERR\n"
   );
   pid
 
-let script_op = {
-  name = "script";
-  enabled_by_default = true;
-  heading = s_"Run arbitrary scripts against the guest";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "script";
+    enabled_by_default = true;
+    heading = s_"Run arbitrary scripts against the guest";
+    pod_description = Some (s_"\
 The C<script> module lets you run arbitrary shell scripts or programs
 against the guest.
 
@@ -139,28 +140,32 @@ can choose a specific one by using the I<--scriptdir> parameter.
 B<Note:> This is different from I<--firstboot> scripts (which run
 in the context of the guest when it is booting first time).
 I<--script> scripts run on the host, not in the guest.");
-  extra_args = [
-    ("--scriptdir", Arg.String set_scriptdir, s_"dir" ^ " " ^ s_"Mount point on host"),
-    s_"\
+    extra_args = [
+      { extra_argspec = "--scriptdir", Arg.String set_scriptdir, s_"dir" ^ " " ^ s_"Mount point on host";
+        extra_pod_argval = Some "SCRIPTDIR";
+        extra_pod_description = s_"\
 The mount point (an empty directory on the host) used when
 the C<script> operation is enabled and one or more scripts
 are specified using I<--script> parameter(s).
 
-B<Note:> C<scriptdir> B<must> be an absolute path.
+B<Note:> C<SCRIPTDIR> B<must> be an absolute path.
 
 If I<--scriptdir> is not specified then a temporary mountpoint
-will be created.";
-    ("--script", Arg.String add_script, s_"script" ^ " " ^ s_"Script or program to run on guest"),
-    s_"\
-Run the named C<script> (a shell script or program) against the
+will be created."
+      };
+
+      { extra_argspec = "--script", Arg.String add_script, s_"script" ^ " " ^ s_"Script or program to run on guest";
+        extra_pod_argval = Some "SCRIPT";
+        extra_pod_description = s_"\
+Run the named C<SCRIPT> (a shell script or program) against the
 guest.  The script can be any program on the host.  The script's
 current directory will be the guest's root directory.
 
 B<Note:> If the script is not on the $PATH, then you must give
 the full absolute path to the script.";
-  ];
-  perform_on_filesystems = Some script_perform;
-  perform_on_devices = None;
+      }
+    ];
+    perform_on_filesystems = Some script_perform;
 }
 
-let () = register_operation script_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_smolt_uuid.ml b/sysprep/sysprep_operation_smolt_uuid.ml
index 295a260..bb560c4 100644
--- a/sysprep/sysprep_operation_smolt_uuid.ml
+++ b/sysprep/sysprep_operation_smolt_uuid.ml
@@ -35,14 +35,12 @@ let smolt_uuid_perform g root =
   )
   else []
 
-let smolt_uuid_op = {
-  name = "smolt-uuid";
-  enabled_by_default = true;
-  heading = s_"Remove the Smolt hardware UUID";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some smolt_uuid_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "smolt-uuid";
+    enabled_by_default = true;
+    heading = s_"Remove the Smolt hardware UUID";
+    perform_on_filesystems = Some smolt_uuid_perform;
 }
 
-let () = register_operation smolt_uuid_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_ssh_hostkeys.ml b/sysprep/sysprep_operation_ssh_hostkeys.ml
index a382c19..6ed7deb 100644
--- a/sysprep/sysprep_operation_ssh_hostkeys.ml
+++ b/sysprep/sysprep_operation_ssh_hostkeys.ml
@@ -30,11 +30,12 @@ let ssh_hostkeys_perform g root =
   )
   else []
 
-let ssh_hostkeys_op = {
-  name = "ssh-hostkeys";
-  enabled_by_default = true;
-  heading = s_"Remove the SSH host keys in the guest";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "ssh-hostkeys";
+    enabled_by_default = true;
+    heading = s_"Remove the SSH host keys in the guest";
+    pod_description = Some (s_"\
 The SSH host keys are regenerated (differently) next time the guest is
 booted.
 
@@ -45,9 +46,7 @@ you a stark warning about the host key changing:
  @    WARNING: REMOTE HOST IDENTIFICATION HAS CHANGED!     @
  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  IT IS POSSIBLE THAT SOMEONE IS DOING SOMETHING NASTY!");
-  extra_args = [];
-  perform_on_filesystems = Some ssh_hostkeys_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some ssh_hostkeys_perform;
 }
 
-let () = register_operation ssh_hostkeys_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_ssh_userdir.ml b/sysprep/sysprep_operation_ssh_userdir.ml
index 280e365..59cce9d 100644
--- a/sysprep/sysprep_operation_ssh_userdir.ml
+++ b/sysprep/sysprep_operation_ssh_userdir.ml
@@ -33,16 +33,19 @@ let ssh_userdir_perform g root =
   )
   else []
 
-let ssh_userdir_op = {
-  name = "ssh-userdir";
-  enabled_by_default = true;
-  heading = s_"Remove \".ssh\" directories in the guest";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "ssh-userdir";
+    enabled_by_default = true;
+    heading = s_"Remove \".ssh\" directories in the guest";
+    pod_description = Some (s_"\
 Remove the C<.ssh> directory of user \"root\" and any other
 users who have a C<.ssh> directory in their home directory.");
-  extra_args = [];
-  perform_on_filesystems = Some ssh_userdir_perform;
-  perform_on_devices = None;
+    pod_notes = Some (s_"\
+Currently this only looks in C</root> and C</home/*> for
+home directories, so users with home directories in other
+locations won't have the ssh files removed.");
+    perform_on_filesystems = Some ssh_userdir_perform;
 }
 
-let () = register_operation ssh_userdir_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_sssd_db_log.ml b/sysprep/sysprep_operation_sssd_db_log.ml
index 0e3c518..70c0c44 100644
--- a/sysprep/sysprep_operation_sssd_db_log.ml
+++ b/sysprep/sysprep_operation_sssd_db_log.ml
@@ -39,14 +39,12 @@ let sssd_db_log_perform g root =
   )
   else []
 
-let sssd_db_log_op = {
-  name = "sssd-db-log";
-  enabled_by_default = true;
-  heading = s_"Remove the database and log files of sssd";
-  pod_description = None;
-  extra_args = [];
-  perform_on_filesystems = Some sssd_db_log_perform;
-  perform_on_devices = None;
+let op = {
+  defaults with
+    name = "sssd-db-log";
+    enabled_by_default = true;
+    heading = s_"Remove the database and log files of sssd";
+    perform_on_filesystems = Some sssd_db_log_perform;
 }
 
-let () = register_operation sssd_db_log_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_tmp_files.ml b/sysprep/sysprep_operation_tmp_files.ml
new file mode 100644
index 0000000..a42ddbd
--- /dev/null
+++ b/sysprep/sysprep_operation_tmp_files.ml
@@ -0,0 +1,52 @@
+(* virt-sysprep
+ * Copyright (C) 2013 Fujitsu Limited.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+open Sysprep_operation
+open Common_gettext.Gettext
+
+module G = Guestfs
+
+let tmp_files_perform g root =
+  let typ = g#inspect_get_type root in
+  if typ <> "windows" then (
+    let paths = [ "/tmp/*";
+                  "/var/tmp/*"; ] in
+    List.iter (
+      fun path ->
+        let files = g#glob_expand path in
+        Array.iter (
+          fun file ->
+            g#rm_rf file;
+        ) files;
+    ) paths;
+
+    []
+  )
+  else []
+
+let op = {
+  defaults with
+    name = "tmp-files";
+    enabled_by_default = true;
+    heading = s_"Remove temporary files";
+    pod_description = Some (s_"\
+This removes temporary files under C</tmp> and C</var/tmp>.");
+    perform_on_filesystems = Some tmp_files_perform;
+}
+
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_udev_persistent_net.ml b/sysprep/sysprep_operation_udev_persistent_net.ml
index 652b9ab..235ef98 100644
--- a/sysprep/sysprep_operation_udev_persistent_net.ml
+++ b/sysprep/sysprep_operation_udev_persistent_net.ml
@@ -30,11 +30,12 @@ let udev_persistent_net_perform g root =
   )
   else []
 
-let udev_persistent_net_op = {
-  name = "udev-persistent-net";
-  enabled_by_default = true;
-  heading = s_"Remove udev persistent net rules";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "udev-persistent-net";
+    enabled_by_default = true;
+    heading = s_"Remove udev persistent net rules";
+    pod_description = Some (s_"\
 Remove udev persistent net rules which map the guest's existing MAC
 address to a fixed ethernet device (eg. eth0).
 
@@ -42,9 +43,7 @@ After a guest is cloned, the MAC address usually changes.  Since the
 old MAC address occupies the old name (eg. eth0), this means the fresh
 MAC address is assigned to a new name (eg. eth1) and this is usually
 undesirable.  Erasing the udev persistent net rules avoids this.");
-  extra_args = [];
-  perform_on_filesystems = Some udev_persistent_net_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some udev_persistent_net_perform;
 }
 
-let () = register_operation udev_persistent_net_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_user_account.ml b/sysprep/sysprep_operation_user_account.ml
index c97b9f4..fc39bc8 100644
--- a/sysprep/sysprep_operation_user_account.ml
+++ b/sysprep/sysprep_operation_user_account.ml
@@ -58,16 +58,19 @@ let user_account_perform g root =
   )
   else []
 
-let user_account_op = {
-  name = "user-account";
-  enabled_by_default = false;
-  heading = s_"Remove the user accounts in the guest";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "user-account";
+    enabled_by_default = false;
+    heading = s_"Remove the user accounts in the guest";
+    pod_description = Some (s_"\
 Remove all the user accounts and their home directories.
 The \"root\" account is not removed.");
-  extra_args = [];
-  perform_on_filesystems = Some user_account_perform;
-  perform_on_devices = None;
+    pod_notes = Some (s_"\
+Currently this does not remove the user accounts from
+C</etc/shadow>.  This is because there is no lens for
+the shadow password file in Augeas.");
+    perform_on_filesystems = Some user_account_perform;
 }
 
-let () = register_operation user_account_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_utmp.ml b/sysprep/sysprep_operation_utmp.ml
index 3e1cab5..be73e16 100644
--- a/sysprep/sysprep_operation_utmp.ml
+++ b/sysprep/sysprep_operation_utmp.ml
@@ -29,17 +29,16 @@ let utmp_perform g root =
   );
   []
 
-let utmp_op = {
-  name = "utmp";
-  enabled_by_default = true;
-  heading = s_"Remove the utmp file";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "utmp";
+    enabled_by_default = true;
+    heading = s_"Remove the utmp file";
+    pod_description = Some (s_"\
 This file records who is currently logged in on a machine.  In modern
 Linux distros it is stored in a ramdisk and hence not part of the
 virtual machine's disk, but it was stored on disk in older distros.");
-  extra_args = [];
-  perform_on_filesystems = Some utmp_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some utmp_perform;
 }
 
-let () = register_operation utmp_op
+let () = register_operation op
diff --git a/sysprep/sysprep_operation_yum_uuid.ml b/sysprep/sysprep_operation_yum_uuid.ml
index 8a864b1..8ffe664 100644
--- a/sysprep/sysprep_operation_yum_uuid.ml
+++ b/sysprep/sysprep_operation_yum_uuid.ml
@@ -29,16 +29,15 @@ let yum_uuid_perform g root =
   )
   else []
 
-let yum_uuid_op = {
-  name = "yum-uuid";
-  enabled_by_default = true;
-  heading = s_"Remove the yum UUID";
-  pod_description = Some (s_"\
+let op = {
+  defaults with
+    name = "yum-uuid";
+    enabled_by_default = true;
+    heading = s_"Remove the yum UUID";
+    pod_description = Some (s_"\
 Yum creates a fresh UUID the next time it runs when it notices that the
 original UUID has been erased.");
-  extra_args = [];
-  perform_on_filesystems = Some yum_uuid_perform;
-  perform_on_devices = None;
+    perform_on_filesystems = Some yum_uuid_perform;
 }
 
-let () = register_operation yum_uuid_op
+let () = register_operation op
diff --git a/tests/guests/guest-aux/make-debian-img.sh b/tests/guests/guest-aux/make-debian-img.sh
index 76d81d3..b5b0961 100755
--- a/tests/guests/guest-aux/make-debian-img.sh
+++ b/tests/guests/guest-aux/make-debian-img.sh
@@ -75,6 +75,7 @@ mount /dev/debian/home /home
 mkdir /bin
 mkdir /etc
 mkdir-p /var/lib/dpkg
+mkdir /var/lib/urandom
 
 upload fstab.tmp.$$ /etc/fstab
 write /etc/debian_version "5.0.1"
diff --git a/tests/guests/guest-aux/make-ubuntu-img.sh b/tests/guests/guest-aux/make-ubuntu-img.sh
index eec80f9..445141f 100755
--- a/tests/guests/guest-aux/make-ubuntu-img.sh
+++ b/tests/guests/guest-aux/make-ubuntu-img.sh
@@ -66,6 +66,7 @@ mkdir /etc
 mkdir /home
 mkdir /usr
 mkdir-p /var/lib/dpkg
+mkdir /var/lib/urandom
 
 upload fstab.tmp.$$ /etc/fstab
 write /etc/debian_version "5.0.1"
-- 
2.7.4

